<?php


class Miniorange_scimControllerAccountsetup extends JControllerForm
{
    function __construct()
    {
        $this->view_list = 'accountsetup';
        parent::__construct();
    }

    function create_bearer_token(){
        MoScimUtilitiesClient::create_bearer_token();
        $this->setRedirect('index.php?option=com_miniorange_scim&view=accountsetup&tab-panel=scimsettings',"New Bearer Token has been generated." );
    }

    function saveAttributeMapping(){
        $app = JFactory::getApplication();
        $post = $app->input->post->getArray();

        if( count($post)==0 ){
            $app->redirect("index.php?option=com_miniorange_scim&view=accountsetup&tab-panel=scimmapping");
            return;
        }

        $userProfileAttributeNames  = isset($post['user_profile_attr_name'])?$post['user_profile_attr_name']:array();
        $userProfileAttributeValues = isset($post['user_profile_attr_value'])?$post['user_profile_attr_value']:array();
        $profileAttributesMap       = MoScimUtilitiesClient::customCombineArray($userProfileAttributeNames,$userProfileAttributeValues);
        $conditions = array('id'=>1);
        $fields     = array("moScimAttributeMap"=>json_encode(array("profile"=>$profileAttributesMap)));

        MoScimUtilitiesClient::miniScimUpdateDb('#__miniorange_scim_details',$fields,$conditions);
        $message =  'Attribute Mapping has been successfully updated.';
        $this->setRedirect('index.php?option=com_miniorange_scim&view=accountsetup&tab-panel=scimmapping',$message );
    }



    function emptyPostCheck($post,$page){
        $app = JFactory::getApplication();
	    $pluginPages = array(
	        'accountsettings'=>'index.php?option=com_miniorange_scim&view=accountsetup&tab-panel=plugin_overview',
             'scimConfig'=>'index.php?option=com_miniorange_scim&view=accountsetup&tab-panel=scimsettings'
        );
	    if(empty($post))
        {
            $app->redirect($pluginPages[$page]);
            return;
        }
    }


    function contactUs()
    {
        $post = JFactory::getApplication()->input->post->getArray();
        $this->emptyPostCheck($post,'account');
        $accountPage = 'index.php?option=com_miniorange_scim&view=accountsetup&tab-panel=plugin_overview';

        if (isset($post['query_phone']) && $post['query_phone'] != NULL) {
            $pgone_num_validate = preg_match("/^\+?[0-9]+$/", $post['query_phone']);
            if (!$pgone_num_validate) {
                $this->setRedirect($accountPage, 'Please submit a valid phone number.', 'error');
                return;
            }
        }

        if (MoScimUtilitiesClient::check_empty_or_null($post['query_email'])) {
            $this->setRedirect($accountPage, 'Please submit your query with email.', 'error');
            return;
        } else if (MoScimUtilitiesClient::check_empty_or_null(trim($post['mo_scim_textfield'] || trim($post['mo_scim_textfield'])))) {
            $this->setRedirect($accountPage, 'Query cannot be empty.', 'error');
            return;
        } else {
            $query = $post['mo_scim_textfield'];
            $email = $post['query_email'];
            $phone = $post['query_phone'];
            $contact_us = new MoScimCustomer();
            $submited = json_decode($contact_us->submit_contact_us($email, $phone, $query), true);
            if (json_last_error() == JSON_ERROR_NONE) {
                if (is_array($submited) && array_key_exists('status', $submited) && $submited['status'] == 'ERROR') {
                    $this->setRedirect($accountPage, $submited['message'], 'error');
                    return;
                } else {
                    if ($submited == false) {
                        $this->setRedirect($accountPage, 'Your query could not be submitted. Please try again.', 'error');
                        return;
                    } else {
                        $this->setRedirect($accountPage, 'Thanks for getting in touch! We shall get back to you shortly.');
                    }
                }
            }
        }
    }
}