<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_miniorange_scim
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted Access');

jimport('miniorangescimplugin.utility.MoScimUtilitiesClient');
jimport("miniorangescimplugin.moscim.moScimuser");

JHtml::_('jquery.framework');
JHtml::_('stylesheet', JUri::base() .'components/com_miniorange_scim/assets/css/miniorange_boot.css');
JHtml::_('stylesheet', JUri::base() .'components/com_miniorange_scim/assets/css/miniorange_scim.css');
JHtml::_('script', JUri::base() . 'components/com_miniorange_scim/assets/js/moScimMapping.js');
JHtml::_('script', JUri::base() . 'components/com_miniorange_scim/assets/js/utility.js');
JHtml::_('script', JUri::base() . 'components/com_miniorange_scim/assets/js/bootstrap.js');
JHtml::_('stylesheet', 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css');


$scim_active_tab = 'plugin_overview';
$active_tab = JFactory::getApplication()->input->get->getArray();

if(isset($active_tab['tab-panel']) && !empty($active_tab['tab-panel'])){
	$scim_active_tab = $active_tab['tab-panel'];
}

?>

 

    <div class="nav-tab-wrapper mo_idp_nav-tab-wrapper ">

        <a id="overview_plugin" class="mo_nav-tab <?php echo $scim_active_tab == 'plugin_overview' ? 'mo_nav_tab_active' : ''; ?>" href="#plugin_overview"
           onclick="add_css_tab('#overview_plugin');" data-toggle="tab"><?php echo JText::_('Plugin Overview'); ?>
        </a>

        <a id="scimconfigtab" class="mo_nav-tab <?php echo $scim_active_tab == 'scimsettings' ? 'mo_nav_tab_active' : ''; ?>" href="#scimconfig"
           onclick="add_css_tab('#scimconfigtab');" data-toggle="tab"><?php echo JText::_('SCIM Configuration'); ?>
        </a>

        <a id="scimmappingtab" class="mo_nav-tab <?php echo $scim_active_tab == 'scimmapping' ? 'mo_nav_tab_active' : ''; ?>" href="#scimmapping"
           onclick="add_css_tab('#scimmappingtab');" data-toggle="tab"><?php echo JText::_('SCIM Mapping'); ?>
        </a>

        <a id="scimrolemap" class="mo_nav-tab <?php echo $scim_active_tab == 'scimrolemapping' ? 'mo_nav_tab_active' : ''; ?>" href="#scimrolemappings"
           onclick="add_css_tab('#scimrolemap');" data-toggle="tab"><?php echo JText::_('Role Mapping'); ?>
        </a>

        <a id="scimadvancetab" class="mo_nav-tab <?php echo $scim_active_tab == 'scimadvancesettings' ? 'mo_nav_tab_active' : ''; ?>" href="#scimadvancesetting"
           onclick="add_css_tab('#scimadvancetab');" data-toggle="tab"><?php echo JText::_('Advance Settings'); ?>
        </a>

        <a id="scimlicensingtab" class="mo_nav-tab <?php echo $scim_active_tab == 'upgradeplans' ? 'mo_nav_tab_active' : ''; ?>" href="#upgradeplans"
           onclick="add_css_tab('#scimlicensingtab');" data-toggle="tab"><?php echo JText::_('Upgrade'); ?>
        </a>

    </div>

    <div class="mo_boot_row tab-content" id="myTabContent">

        <div class="mo_boot_col-sm-12 tab-pane <?php echo $scim_active_tab == 'plugin_overview' ? 'active' : ''; ?>" id="plugin_overview" >
            <div class="mo_boot_row mo_saml_table_layout_1">
                <div class="mo_boot_col-sm-8 mo_saml_table_layout mo_scim_page_border">
                    <?php plugin_overview();?>
                </div>
                <div  class="mo_saml_table_layout_support_1 mo_boot_col-sm-4 mo_scim_page_border">
                    <?php mo_scim_support(); ?>
                </div>
            </div>
        </div>


        <div class="mo_boot_col-sm-12 tab-pane <?php echo $scim_active_tab == 'scimsettings' ? 'active' : ''; ?>"   id="scimconfig" >
            <div class="mo_boot_row mo_saml_table_layout_1">
                <div class="mo_boot_col-sm-8 mo_saml_table_layout mo_scim_page_border">
                    <?php scimconfig();?>
                </div>
                <div  class="mo_saml_table_layout_support_1 mo_boot_col-sm-4 mo_scim_page_border">
                    <?php mo_scim_support(); ?>
                </div>
            </div>
        </div>

        <div class="mo_boot_col-sm-12 tab-pane <?php echo $scim_active_tab == 'scimmapping' ? 'active' : ''; ?>"   id="scimmapping" >
            <div class="mo_boot_row mo_saml_table_layout_1" >
                <div class="mo_boot_col-sm-8 mo_saml_table_layout mo_scim_page_border">
                    <?php scimMapping();?>
                </div>
                <div class="mo_saml_table_layout_support_1 mo_boot_col-sm-4 mo_scim_page_border">
                    <?php mo_scim_support(); ?>
                </div>
            </div>
        </div>

        <div class="mo_boot_col-sm-12 tab-pane <?php echo $scim_active_tab == 'scimrolemapping' ? 'active' : ''; ?>"   id="scimrolemappings" >
            <div class="mo_boot_row mo_saml_table_layout_1">
                <div class="mo_boot_col-sm-8 mo_saml_table_layout mo_scim_page_border">
                    <?php scimRoleMapping();?>
                </div>
                <div  class="mo_saml_table_layout_support_1 mo_boot_col-sm-4 mo_scim_page_border" >
                    <?php mo_scim_support(); ?>
                </div>
            </div>
        </div>

        <div class="mo_boot_col-sm-12 tab-pane <?php echo $scim_active_tab == 'scimadvancesettings' ? 'active' : ''; ?>"   id="scimadvancesetting" >
            <div class="mo_boot_row mo_saml_table_layout_1">
                <div class="mo_boot_col-sm-8 mo_saml_table_layout mo_scim_page_border">
                    <?php scimAdvanceSettings();?>
                </div>
                <div  class="mo_saml_table_layout_support_1 mo_boot_col-sm-4 mo_scim_page_border" >
                    <?php mo_scim_support(); ?>
                </div>
            </div>
        </div>

        <div class="mo_boot_col-sm-12 tab-pane <?php echo $scim_active_tab == 'upgradeplans' ? 'active' : ''; ?>" id="upgradeplans">
            <div class="mo_boot_row mo_saml_table_layout_1">
                <div class="mo_boot_col-sm-12 ">
                    <?php mo_scim_licensing_page(); ?>
                </div>
            </div>
        </div>
    </div>
<?php


function plugin_overview()
{
    ?>
    <div class="mo_boot_row mo_boot_m-1  mo_boot_p-3">
        <div class="mo_boot_col-sm-12">
            <h4>Plugin Overview</h4>
        </div>
        <div class="mo_boot_row mo_boot_p-2">
            <div class="mo_boot_col-12">
                <hr><p>
                    miniOrange provides a ready to use solution for Joomla User Provisioning using SCIM (System for Cross-domain Identity Management) standard.
                    This solution ensures that you can add, update, delete, and deactivate user operations with Joomla using the SCIM User Provisioner plugin.
                    <br><br><b>For example</b>: As an Identity Provider add, update, and delete the users, they are added, updated, and removed from the Joomla User Profile.
                    To achieve this functionality IDPs provides the User Provisioner with SCIM standard.
                </p>
                <p>
                    If your users are using both IDP (eg. Azure AD, OKTA, OneLogin, etc) and Joomla website, it is preferred to have all users updated in the Joomla site without login each time to update the user list. miniOrange provides a solution that allows user provisioning into a Joomla website using SCIM standard.
                </p>
                <p>
                    Currently you are on the free version and this plugin is only for POC purposes. You can only create the users whenever the new users will be created in your IDP end.
                </p><hr>
            </div>
        </div>

    </div>
    <?php

}

function scimconfig() {
    $groups = MoScimUtilitiesClient::loadGroups();
    $scimConfig = MoScimUtilitiesClient::get_scim_config();
    if ($scimConfig['bearer_token'] == "") {
        $bearer_token = MoScimUtilitiesClient::create_bearer_token();
    } else {
        $bearer_token = $scimConfig['bearer_token'];
    }
    $premiumDisabled = 'enabled';
    $selectedRoles = json_decode($scimConfig['default_roles'], true);
    $moScimParentRole = $scimConfig['moScimParentRole'];
    $scim_url = JURI::root() . 'index.php/miniorangescim';

    ?>
    <div class="mo_boot_row mo_boot_m-1  mo_boot_p-3">
        <div class="mo_boot_col-sm-12">
            <h4>SCIM Configuration</h4><hr>
            <input type="hidden" name="option" value="" />
        </div>
        <div class="mo_boot_col-4">
            <strong>Select your Identity Provider: </strong>
        </div>
        <div class="mo_boot_col-8">
            <select name="idpguide" id="idpguide" class="mo_boot_form-control scim-table mo_scim_textfield">
                <option value="" selected="" disabled="">Select your IDP for setup guide</option>
                <option value="https://plugins.miniorange.com/joomla-azure-ad-user-sync-provisioning">Azure AD</option>
                <option value="https://plugins.miniorange.com/joomla-onelogin-user-sync-provisioning">One Login</option>
                <option value="https://plugins.miniorange.com/joomla-okta-user-sync-provisioning">Okta</option>
                <option value="https://plugins.miniorange.com/joomla-scim-user-provisioning-with-jumpcloud">Jump Cloud</option>
                <option value="https://plugins.miniorange.com/wordpress-scim-user-provisioning-with-google-apps">Google Apps</option>
                <option value="https://plugins.miniorange.com/wordpress-scim-user-provisioning-with-pingone">Ping One</option>
                <option value="https://plugins.miniorange.com/wordpress-scim-user-provisioning">miniOrange</option>
                <option value="https://plugins.miniorange.com/wordpress-scim-user-provisioning-with-centrify">Centrify</option>
                <option value="https://plugins.miniorange.com/drupal-scim-cyberark-user-provisioning">CyberArk</option>
                <option value="https://plugins.miniorange.com/joomla-scim-user-provisioning">Others</option>
            </select>
        </div>
        <form name="f" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_scim&view=accountsetup&task=accountsetup.create_bearer_token'); ?>">
            <div class="mo_boot_col-sm-12 mo_boot_table-responsive mo_boot_mt-3">
                <table class="mo_boot_table mo_boot_table-bordered">
                    <tr>
                        <td><b>SCIM Base URL</b></td>
                        <td><span id="base_url"><?php echo $scim_url; ?></span> <em class="fa fa-lg fa-copy mo_copy" onclick="copyToClipboard('#base_url');" style="float:right;color:black;"> </em></td>
                    </tr>
                    <tr>
                        <td><b>SCIM Bearer Token</b></td>
                        <td><span id="bearer_token"><?php echo $bearer_token; ?></span> <em class="fa fa-lg fa-copy mo_copy" onclick="copyToClipboard('#bearer_token');" style="float:right;color:black;"> </em></td>
                    </tr>
                </table>
                <div class="mo_boot_col-sm-12 mo_boot_text-center mo_boot_mt-3">
                    <input type="submit" value="Generate New Token" class="mo_tfa_input_submit mo_boot_btn mo_boot_btn-primary">
                </div><br><br>
            </div>
            <strong style="color: red;">Note: </strong>To create new users you will need to Map the attributes under <a href='<?php echo JURI::base()?>index.php?option=com_miniorange_scim&tab-panel=scimmapping'>SCIM Mapping tab</a>.
        </form>

        <div class="mo_boot_col-sm-12 mo_boot_mt-4">
            <div class="mo_boot_row">
                <div class="mo_boot_col-sm-12 alert alert-info" style="color: #151515;">
                    <h4>Instructions:</h4><hr>
                    <ol>
                        <li>1. Enter the above SCIM Base URL and Bearer Token on your SCIM Client (IDP).</li>
                        <li>2. Once done with above configuration, you will be able to perform add, update and delete operations on SCIM Client (IDP).</li>
                    </ol>
                </div>
            </div><br>
        </div>

        <details style="width: 100%;" open>
            <summary class="mo_scim_summary">SCIM OPERATIONS</summary><hr>
            <div class="mo_boot_row">
                <div class="mo_boot_col-sm-12">
                    <dl>
                        <dd>
                            <strong>Create:</strong> It will create user using First Name, Last Name, Email and Username.
                        </dd>
                        <dd  class="mo_boot_mt-1">
                            <p><strong>Note: </strong>If Username field is blank, it will pick email as a username, as Joomla does not accept blank Username.</p>
                        </dd>
                        <dd  class="mo_boot_mt-3">
                            <strong>Delete:</strong> A user will also be deleted from the Joomla User list once they have been deleted from your IDP or SCIM Client.
                        </dd>
                        <dd  class="mo_boot_mt-3">
                            <strong>Update:</strong> It will update the user fields, all attributes/fields except email and username.
                        </dd>
                        <dd class="mo_boot_mt-3">
                            <strong>Deactivate:</strong>A user will also be deleted/deactivated/disabled from the Joomla User list once they have been deleted/deactivated/unassinged from your IDP or SCIM Client.
                        </dd>
                    </dl>
                </div>
            </div>
        </details>
    </div>
    <script>
        jQuery('#idpguide').on('change', function () {
            var selectedIdp = jQuery(this).find('option:selected').val();
            window.open(selectedIdp, '_blank');
        });
    </script>
    <?php
}

function scimMapping(){
    $mappingDetails = MoScimUtilitiesClient::get_scim_config()['moScimAttributeMap'];
    $mappingDetails = json_decode($mappingDetails,true)['profile'];
    ?>
     <div class="mo_boot_row mo_boot_m-1  mo_boot_p-3">
        <div class="mo_boot_col-sm-12">
            <h4>SCIM Mapping</h4><hr>
            <input type="hidden" name="option" value="" />
        </div>
         <form name="advance_attr_mapping_form" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_scim&view=accountsetup&task=accountsetup.saveAttributeMapping'); ?>">
         <div class="mo_boot_container" id="userProfileAttrDiv" style="margin-left:2%;">
             <h5> Add Joomla's User Profile Attributes <input type="button" class="mo_boot_btn mo_boot_btn-primary" id="moScimUserProfilePlusButton"  value="+"  /> </h5>
             <p class="alert alert-info" style="color: #151515;"><strong>NOTE:</strong> Whenever your user will be created or updated on your SCIM Client (IDP) side, the value corresponding to User Profile Attributes Mapping Value from your SCIM Client(IDP) will be updated for the User Profile Attribute field in User Profile table of Joomla.</p>

             <br><br><div class="mo_boot_row  moScimAttributeColumns" style="margin-left: -1%;">
                 <div><h6>Joomla Attribute Name</h6></div>
                 <div style="margin-left: 8%;"><h6>SCIM Client(IDP) Attribute Name</h6></div>
             </div>

             <?php
             $counter = 0;
             $allUserAttributes = MoScimUtilitiesClient::getAllAttributesOfUserSchema();
             echo "<input type='hidden' id='moScimUserFieldsFromDb' value='".json_encode($allUserAttributes)."'/>";
             $allJoomlaAttributes = array(
                 'u_email'=>'email',
                 'u_username'=>'username'
             );
             $userFieldAttributes = MoScimUtilitiesClient::miniScimFetchDb('#__fields',array('context'=>'com_users.user'),'loadAssocList',array('name','label'));

             
             foreach ($userFieldAttributes as $value){
                $allJoomlaAttributes[$value['name']]=$value['label'];
             }

             echo "<input type='hidden' id='moScimAllJoomlaAttributes' value='".json_encode($allJoomlaAttributes)."'/>";

             
             foreach ($mappingDetails as $key=>$value) {
                 $options="";

                 foreach ($allUserAttributes as $fieldID){
                     $options = $options . "<option value='".$fieldID."' ".($key==$fieldID?"selected":"").">".$fieldID."</option>";
                 }
                 $options1='<optgroup label="User Table Fields">';
                 $type = "user";

              
                 foreach ($allJoomlaAttributes as $key1=>$userField){

                     if($type=="user" && substr($key1,0,3)=="up_"){
                         $type = "userField";
                         $options1 = $options1.'</optgroup><optgroup label="User Profile Fields">';
                     }
                     elseif($type=="userField" && substr($key1,0,3)!="up_"){
                         $options1 = $options1.'</optgroup><optgroup label="User Field Attributes">';
                     }
                     $options1 = $options1 . '<option value="'.$key1.'" '.($value==$key1?"selected":"").'>'.$userField.'</option>';
                 }
                 $options1 = $options1 . '</optgroup>';

                 echo '<div class="mo_boot_row userAttr userProfileAttributeRows" style="padding-bottom:1%;" id="uparow_profile_' . $counter . '" >
                     <select type="text" class="moScimAttributeValue mo_scim_textfield" name="user_profile_attr_value[' . $counter . ']" value="' . $key1 . '"  style="margin-left: 3% !important;height:28px;width: 35% !important;border: 1px solid #ccc;background-color: #fff;" >'.$options1.'</select>
                     <select type="text" class="moScimAttributeName mo_scim_textfield" name="user_profile_attr_name[' . $counter . ']" value="' .$key . '" style="margin-left: 3% !important;height:28px;width: 35% !important;border: 1px solid #ccc;background-color: #fff;">'.$options.'</select>
                     <input type="button" class="mo_boot_btn mo_boot_btn-danger userAttributeMinusButton" name="user_profile_attr_minus_button[' . $counter . ']" style="margin:0px 0px 8px 10px;" value="-" onclick="remove_user_attibute(this)"/>
                  </div>';
                 $counter += 1;
             }
           
                 ?></div><br><input type="submit" name="moOauthAttrMapSaveButton" class="mo_boot_btn mo_boot_btn-primary" style="display: block;margin-left: 35.5%;" value="Save Settings"/><hr>
         </form><br>

         <div class="mo_boot_container" id="userProfileAttrDiv" style="margin-left:2%;">
             <h5> Advance Joomla's User Profile Attributes <sup><a href='<?php echo JURI::base()?>index.php?option=com_miniorange_scim&tab-panel=upgradeplans'> Standard, Premium</a></sup><input type="button" class="mo_boot_btn mo_boot_btn-primary" disabled value="+" /></h5>

             <br><br><div class="mo_boot_row  moScimAttributeColumns" style="margin-left: -1%;">
                 <div><h6>SCIM Client(IDP) Attribute Name</h6></div>
                 <div style="margin-left: 8%;"><h6>Joomla User Profile Attributes</h6></div>
             </div><?php

             $counter = 0;

             $options = "<option value='userName'>userName</option>";
             $options1='<optgroup label="User Table Fields">';
             $options1 = $options1 . '<option value="name">name</option></optgroup>';

             echo '<div class="mo_boot_row userAttr userProfileAttributeRows" style="padding-bottom:1%;" id="uparow_profile_' . $counter . '" >
                       <select type="text" class="moScimAttributeName mo_scim_textfield" disabled style=" margin-left: 3% !important;height:28px;width: 35% !important;border: 1px solid #ccc;background-color: #fff;">'.$options.'</select>
                       <select type="text" class="moScimAttributeValue mo_scim_textfield" disabled style=" margin-left: 3% !important;height:28px;width: 35% !important;border: 1px solid #ccc;background-color: #fff;" >'.$options1.'</select>
                  </div>';
             ?><br></div><input type="submit" class="mo_boot_btn mo_boot_btn-primary" disabled style="display: block;margin-left: 35.5%;" value="Save Settings"/>
     </div>
     <?php

}

function scimRoleMapping()
{
    $groups = MoScimUtilitiesClient::loadGroups();
    $scimConfig = MoScimUtilitiesClient::get_scim_config();
    if ($scimConfig['bearer_token'] == "") {
        $bearer_token = MoScimUtilitiesClient::create_bearer_token();
    } else {
        $bearer_token = $scimConfig['bearer_token'];
    }
    $premiumDisabled = 'enabled';
    $selectedRoles = json_decode($scimConfig['default_roles'], true);
    $moScimParentRole = $scimConfig['moScimParentRole'];
    $scim_url = JURI::root() . 'index.php/miniorangescim';

    ?>
    <div class="mo_boot_row mo_boot_m-1  mo_boot_p-3">
       <div class="mo_boot_col-sm-12">
            <h4>Role Mapping<sup><a href='<?php echo JURI::base()?>index.php?option=com_miniorange_scim&tab-panel=upgradeplans'> Standard, Premium</a></sup></h4><hr>
       </div><hr>
       <div class="mo_boot_col-sm-12 moJoom-scimClient-supportForm"  id="moJoom-scimClient-supportForm" >
           <form name="f" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_scim&view=accountsetup&task=accountsetup.defaultRoles'); ?>">
                <div class="mo_boot_row">
                    <div class="mo_boot_col-sm-12">
                        <h5>New role created by SCIM must be child of:</h5>
                    </div>
                    <?php

                    foreach ($groups as $key => $value) {
                        $pre =  $key%2==0?'<tr>':'';
                        $post = $key%2==1|| count($groups)==$key?'</tr>':'';
                        if( $value['id']==$moScimParentRole )
                            echo $pre.'<div class="mo_boot_col-sm-6 mo_boot_mt-2"><input type="radio" value="'.$value['id'].'" name="moScimParentRole" disabled checked="true" /></td><td style="padding-top:3px;">&emsp;'.$value['title'].'</div>'.$post;
                        else
                            echo $pre.'<div class="mo_boot_col-sm-6  mo_boot_mt-2"><input type="radio" value="'.$value['id'].'" name="moScimParentRole" disabled /></td><td style="padding-top:3px;">&emsp;'.$value['title'].'</div>'.$post;
                    }
                    ?>

                </div><br>

                <div class="mo_boot_row">
                    <div class="mo_boot_col-sm-12">
                        <h5>Assign these roles to all SCIM users:</h5>
                    </div>
                    <?php

                    foreach ($groups as $key => $value) {

                        $pre =  $key%2==0?'<tr>':'';
                        $post = $key%2==1|| count($groups)==$key?'</tr>':'';

                        if( in_array($value['id'], $selectedRoles) )
                            echo $pre.'<div class="mo_boot_col-sm-6 mo_boot_mt-2"><input  type="checkbox" value="mo_scim" disabled name="'.str_replace(' ', '_', $value['id']).'" checked="true" /></td><td style="padding-top:3px;">&emsp;'.$value['title'].'</div>'.$post;
                        else
                            echo $pre.'<div class="mo_boot_col-sm-6  mo_boot_mt-2"><input type="checkbox" value="mo_scim" disabled name="'.str_replace(' ', '_', $value['id']).'" /></td><td style="padding-top:3px;">&emsp;'.$value['title'].'</div>'.$post;
                    }
                    ?>
                    <div class="mo_boot_col-sm-12 mo_boot_text-center mo_boot_mt-5">
                        <p><input type="submit" value="Save Configurations" class="mo_tfa_input_submit mo_boot_btn mo_boot_btn-primary" disabled></p>
                    </div>
                </div>
            </form>
        </div>
    </div>


    <?php

}

function scimAdvanceSettings()
{
    ?>
     <div class="mo_boot_row mo_boot_m-1  mo_boot_p-3">
         <div class="mo_boot_col-sm-12">
             <h4>Advance Settings<sup><a href='<?php echo JURI::base()?>index.php?option=com_miniorange_scim&tab-panel=upgradeplans'> Premium</a></sup></h4><hr>
            <input type="hidden" name="option" value="" />
         </div>
         <form id="" name="advance_attr_mapping_form" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_scim&view=accountsetup&task=accountsetup.saveAdvanceSettings'); ?>">
             <div class="mo_boot_col-sm-12 mo_boot_mt-8">
                 <p>Perform the following action on Joomla user list when user is deleted from IDP:</p>
                 <input  type="radio" checked="true" disabled/>&emsp;Do nothing<br><br>
                 <input  type="radio" disabled/>&emsp;Deactivate Users<br><br>
                 <input  type="radio" disabled/>&emsp;Delete Users
            </div><br><br>
             <input type="submit" name="moOauthAttrMapSaveButton" class="mo_boot_btn mo_boot_btn-primary" style="display: block;margin-left: 54%;" value="Save Settings" disabled=""/>
         </form>
     </div> <?php
}

function mo_scim_licensing_page()
{
    $result = MoScimUtilitiesClient::getCustomerDetails();
    $user_email = isset($result['email']) ? $result['email'] : '';

    ?>
 
    <div class="mo_boot_col-sm-12">
        <div class="mo_saml_table_layout mo_scim_page_border" style="background-color: #ecf2f2;margin-top:2%!important;margin-bottom:2%;">
            <div class="tab-pane active text-center" id="cloud">
                <div class="cd-pricing-container cd-has-margins"><br>
                    <h2 style="text-align:center">Licensing Plan</h2><hr>
                    <ul class="cd-pricing-list cd-bounce-invert">
                        <li class="cd-black">
                            <ul class="cd-pricing-wrapper"  style="height: 500px";>
                                <li id="singlesite_tab" data-type="singlesite" class="mosslp is-visible cd-singlesite" style="width: 100%">
                                    <header class="cd-pricing-header" style="height: 200px">
                                        <h2 style="margin-bottom: 10px" >Free<br/></h2><br><br>
                                        <div class="cd-price mo_boot_mt-3" >
                                            <span id="plus_total_price" style="font-weight: bolder;font-size: xx-large">$0*</span>
                                        </div>
                                    </header> <!-- .cd-pricing-header -->
                                    <footer class="cd-pricing-footer">
                                        <a class="cd-select" style="font-size: 85.5%;color:White;background-color:#0d3663;" ><strong>Current Active Plan</strong></a>
                                    </footer><br>
                                    <div class="cd-pricing-body">
                                        <ul class="cd-pricing-features">
                                            <li style="font-size: medium">Create Users</li>
                                            <li style="font-size: medium">Real-time provisioning</li>
                                            <li style="font-size: medium">Pre-configured IDPs</li>
                                            <li style="font-size: medium"><br></li>
                                            <li style="font-size: medium"><br></li>
                                            <li style="font-size: medium"><br></li>
                                            <li style="font-size: medium"><br></li>
                                            <li style="font-size: medium"><br></li>
                                            <li style="font-size: medium"><br></li>
                                            <li style="font-size: medium">End to End Identity Provider Configuration **<br></li>
                                        </ul>
                                    </div>
                                </li>
                            </ul> <!-- .cd-pricing-wrapper -->
                        </li>
                        <li class="cd-black">
                            <ul class="cd-pricing-wrapper">
                                <li id="singlesite_tab" data-type="singlesite" class="mosslp is-visible" style="height=600px; width: 100%; left: 30%; ">
                                    <header class="cd-pricing-header" style="height: 200px">
                                        <h2 style="margin-bottom: 10px">Premium<br/></h2>
                                        <strong>(Deactive, Delete/Deprovisioning Users)</strong>
                                        <div class="cd-price mo_boot_mt-3" >
                                            <span id="plus_total_price" style="font-weight: bolder;font-size: xx-large">$299*</span>
                                        </div><br>
                                       
                                    </header> <!-- .cd-pricing-header -->
                                    <footer class="cd-pricing-footer">
                                        <?php
                                       
                                            $redirect= "https://portal.miniorange.com/initializePayment?requestOrigin=joomla_scim_premium_plan";
                                            echo '<a target="_blank" class="cd-select" style="font-size: 85.5%; cursor: pointer;"  href="'.$redirect.'" >UPGRADE NOW</a>';
                                        
                                        ?>
                                    </footer><br>
                                    <div class="cd-pricing-body">
                                        <ul class="cd-pricing-features">
                                            <li style="font-size: medium">Create Users</li>
                                            <li style="font-size: medium">Real-time provisioning</li>
                                            <li style="font-size: medium">Pre-configured IDPs</li>
                                            <li style="font-size: medium">Generate New Token<br></li>
                                            <li style="font-size: medium">Update Users</li>
                                            <li style="font-size: medium">Group Mapping<br></li>
                                            <li style="font-size: medium">Custom Attribute Mapping<br></li>
                                            <li style="font-size: medium">Deactivate Users</li>
                                            <li style="font-size: medium">Deprovisioning/Delete Users<br></li>
                                            <li style="font-size: medium">End to End Identity Provider Configuration **<br></li>
                                        </ul>
                                    </div> <!-- .cd-pricing-body -->
                                </li>
                            </ul> <!-- .cd-pricing-wrapper -->
                        </li>
                    </ul> <!-- .cd-pricing-list -->
                </div> <!-- .cd-pricing-container -->
            </div>
            <!-- Modal -->
            <br/><br/>
            <br/>
            <script>
                var modal = document.getElementById("myModal");
                var btn1 = document.getElementById("upgrade_Btn1");
                var btn2 = document.getElementById("upgrade_Btn2");

                var span = document.getElementsByClassName("scim_modal_close")[0];
                btn1.onclick = function() {
                    modal.style.display = "block";
                }
                btn2.onclick = function() {
                    modal.style.display = "block";
                }
                span.onclick = function() {
                    modal.style.display = "none";
                }

                // When the user clicks anywhere outside of the modal, close it
                window.onclick = function(event) {
                    if (event.target == modal) {
                        modal.style.display = "none";
                    }
                }
            </script>

            <!--Don't delete below function call-->
        </div>
        
        <div class="mo_saml_table_layout mo_scim_page_border" style="margin-top:2%;margin-bottom:2%;">
            <div  style="padding-top: 1px;">
                <h2 style="text-align:center">HOW TO UPGRADE TO PREMIUM</h2>
            </div> <hr>
            <section   id="section-steps" >
                <div class="mo_boot_col-sm-12 mo_boot_row ">
                    <div class=" mo_boot_col-sm-6 works-step">
                        <div><strong>1</strong></div>
                        <p>
                            Click on <strong><em>Upgrade Now</em></strong> button for required license version and you will be redirected to register with miniorange page. After registration click on  <strong><em>Upgrade Now</em></strong> and you will be redirected to<span stye="margin-left:10px"></span> miniOrange login console.
                        </p>
                    </div>
                    <div class="mo_boot_col-sm-6 works-step">
                        <div><strong>4</strong></div>
                            <p>
                                You can download the license version plugin from the <strong><em>View License > Releases and Downloads</em></strong> section on the miniOrange console.
                            </p>
                    </div>
                            
                </div>
                <div class="mo_boot_col-sm-12 mo_boot_row ">
                    <div class=" mo_boot_col-sm-6 works-step">
                        <div><strong>2</strong></div>
                            <p>
                                Enter your miniOrange account credentials. You can create one for free <em><strong><a href="<?php echo JURI::base()?>index.php?option=com_miniorange_saml&tab=account">here</a></strong></em> if you don't have. Once you have successfuly logged in, you will be redirected towards the payment page.
                            </p>
                    </div>
                    <div class="mo_boot_col-sm-6 works-step">
                        <div><strong>5</strong></div>
                        <p>
                            Uninstall the free plugin that is currently installed from the JOOMLA admin dashboard.
                        </p>
                    </div>           
                </div>
                <div class="mo_boot_col-sm-12 mo_boot_row ">
                    <div class="mo_boot_col-sm-6 works-step">
                        <div><strong>3</strong></div>
                            <p>
                                Enter your card details and proceed for payment. On successful payment completion, the license version plugin will be available to download. 
                            </p>
                        </div>
                        <div class=" mo_boot_col-sm-6 works-step">
                            <div><strong>6</strong></div>
                            <p>
                            Now install the downloaded license version plugin and login using the account which you have used for the purchase of license version plugin.<br> <br>
                            </p>
                        </div>
                        
                    </div> 
            </section>
        </div>

        <div class="mo_saml_table_layout mo_scim_page_border" style="margin-top:2%;margin-bottom:2%;">
            <h2 style="text-align:center">ACCEPTED PAYMENT METHODS</h2><hr>
                <section style="height: 350px;" ><br>
                    <div class="mo_boot_col-sm-12 mo_boot_row">  
                            <div class="mo_boot_col-sm-6">
                                <div class="plan-box">
                                    <div style="background-color:white; border-radius:10px; ">
                                        <em style="font-size:30px;" class="fa fa-cc-amex" aria-hidden="true"></em>
                                        <em style="font-size:30px;" class="fa fa-cc-visa" aria-hidden="true"></em>
                                        <em style="font-size:30px;" class="fa fa-cc-mastercard" aria-hidden="true"></em>
                                    </div>
                                    <div >
                                        If the payment is made through Credit Card/International Debit Card, the license will be created automatically once the payment is completed.
                                    </div>
                                </div>
                            </div>
                            <div class="mo_boot_col-sm-6">
                                <div class="plan-box">
                                    <div style="background-color:white; border-radius:10px; ">
                                        <img class="payment-images card-image" src="" alt=""> 
                                        <em style="font-size:30px;" class="fa fa-university" aria-hidden="true"><span style="font-size: 20px;font-weight:500;">&nbsp;&nbsp;Bank Transfer</span></em>
                                        
                                    </div>
                                    <div> 
                                        If you want to use bank transfer for the payment then contact us at <strong><em><span>info@xecurify.com</span></em></strong>  so that we can provide you the bank details.
                                    </div>
                                </div>
                            </div>  
                    </div>
                    <div class="row">
                            <p style="margin-top:20px;font-size:16px;text-align:center">
                                <span style="font-weight:500;"> Note :</span> Once you have paid through PayPal/Net Banking, please inform us so that we can confirm and update your license.
                            </p>
                    </div>
                </section>
        </div>

        <div class="mo_saml_table_layout mo_scim_page_border" style="margin-top:2%;margin-bottom:2%;">
            <h2 style="text-align:center">LICENSING POLICY</h2><hr>
            <div style="margin-left: 33px;"><br>
                    <h4>This is the price for 1 instance. Check our <a style="color:blue;" href="https://login.xecurify.com/moas/login?username=&redirectUrl=https://login.xecurify.com/moas/initializepayment&requestOrigin=joomla_scim_premium_plan" target='_blank'>payment page</a> for full details.</h4>
                    <br>
        
                    <h4>* End to End Identity Provider Integration - </h4>
                    <p>We will setup a Conference Call / Gotomeeting and do end to end configuration for your IDP as well as plugin. We provide services to do the configuration on your behalf.</p>
                    <p>If you have any doubts regarding the licensing plans, you can email us at <a href="mailto:joomlasupport@xecurify.com">joomlasupport@xecurify.com</a>.</p>
                    <h3>Return Policy -</h3>
                    <p>If the licensed plugin you purchased is not working as advertised and you’ve attempted to resolve any feature issues with our support team, which couldn't get resolved,
                        we will refund the whole amount. If the request for issue resolution is made within 10 days of the purchase, the issue will be resolved within the period stated by the team.

                        <br><br><strong>Note that this policy does not cover the following cases:</strong>
                        <li>1. Change in mind or change in requirements after purchase.</li>

                        <li>2. Infrastructure issues do not allow the functionality to work.</li>
                    </p><br>
            </div>
        </div>
    </div>
    <style>
        .cd-black :hover #singlesite_tab.is-visible{
            margin-right : 4px;
            transition : 0.4s;
            -moz-transition : 0.4s;
            -webkit-transition : 0.4s;
            border-radius: 8px;
            transform: scale(1.03);
            -ms-transform: scale(1.03); /* IE 9 */
            -webkit-transform: scale(1.03); /* Safari */

            box-shadow: 0 0 4px 1px rgba(255,165, 0, 0.8);
        }
        h1 {
            margin: .67em 0;
            font-size: 2em;
        }

        ul {
            list-style: none; /* Remove HTML bullets */
            padding: 0;
            margin: 0;
        }

        li {
            list-style: none; /* Remove HTML bullets */
            padding: 0;
            margin: 0;
        }
    </style>
    <?php
}



function mo_scim_support(){
?>
    <div class="mo_boot_row mo_boot_m-1">
        <div class="mo_boot_col-sm-12 mo_boot_text-center">
            <h3>Support</h3>
            <hr>
        </div>
        <div class="mo_boot_col-sm-12">
            <form name="f" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_scim&view=accountsetup&task=accountsetup.contactUs');?>">
                <div class="mo_boot_row scim-table">
                    <div class="mo_boot_col-sm-12">
                        <p >Need any help? Just send us a query and we will get back to you soon.</p>
                    </div>
                </div>
                <div class="mo_boot_row scim-table mo_boot_text-center">
                    <div class="mo_boot_col-sm-12">
                        <input type="email" class="mo_boot_form-control scim-table mo_scim_textfield" name="query_email" value="" placeholder="Enter your email" required />
                    </div><br><br>
                    <div class="mo_boot_col-sm-12">
                        <input type="text" class="mo_boot_form-control scim-table mo_scim_textfield" name="query_phone" value="" placeholder="Enter your phone with country code"/>
                    </div><br><br>
                    <div class="mo_boot_col-sm-12">
                        <textarea class="mo_scim_textfield" name="mo_scim_textfield" style="border-radius:4px;resize: vertical;width:100%" cols="52" rows="4" placeholder="Write your query here" required></textarea>
                    </div>
                    <div class="mo_boot_col-sm-12">
                        <br><input type="submit" name="send_query" value="Submit Query" class="mo_boot_btn mo_boot_btn-primary" />
                    </div>
                </div>
            </form>
        </div>
    </div>
<?php
}


